/*
*/

import vrml.*;
import vrml.field.*;
import vrml.node.*;

public class 
Example4 extends Script 
{
  private boolean DEBUG = true;

  // Declare fields
  private SFColor currentColor;

  //
  private SFVec3f set_position;

  //
  private float valBuf[] = new float[3];

  private float count = 0.0f;
  private float step = 0.2f;

  CylinderUI ui;

  private Browser             browser        = null;
  private SFNode              rootNode       = null;
  private MFNode       addChildren    = null;
  private MFNode       removeChildren = null;
  private MFNode                myNode       = null;
  private Node                myTransform[]  = null;

  public void initialize()
  {
     set_position = (SFVec3f) getEventOut("set_position");

     ui = new CylinderUI(this);

     // ** Now it is time to get the handle of browser
     browser = (Browser) getBrowser();

     if(DEBUG==true) System.out.println("after browser handle ");
         
     if(DEBUG==true) System.out.println("before rootNode handle ");
     rootNode = (SFNode) getField("CYLINDER");
     if(DEBUG==true) System.out.println("after rootNode handle ");
      
     // Get EventIns of the rootNode
     //addChildren = (MFNode) ((Node)rootNode.getValue()).getEventIn("addChildren");
     addChildren = (MFNode) getEventOut("addChildren");

     if(DEBUG == true ) System.out.println(" addChildren is registered !! ");

     //removeChildren = (MFNode) ((Node)rootNode.getValue()).getEventIn("removeChildren");
     removeChildren = (MFNode) getEventOut("removeChildren");
      
     if(DEBUG == true ) System.out.println(" removeChildren is registered !! ");

     addChildrenNode(1.0f, 1.0f, true , true, true, true );
     System.out.println(" after initialize()!! ");
     
  }// end of initialize()

  //...
  // This method is called when any event is received
  public void 
  processEvent(Event e)
  {
    System.out.println(" I received "+e.getName()+" time "+e.getTimeStamp());
    System.out.println(" I received "+e.getName());

    if(e.getName().equals("clicked"))
    {
       
       //valBuf[0] = (float) (1.0+e.getTimeStamp()*1.0);
       //valBuf[1] = (float) (Math.sin(e.getTimeStamp()*6.28)); 
       valBuf[0] = (float) (1.0+count*1.0);
       valBuf[1] = (float) (Math.sin(count*6.28)); 
       valBuf[2] = 0.0f;
       set_position.setValue(valBuf);
       count += step;
       if(count>3.14 || count<0) 
       {
         step = -1.0f * step;
         count += step;
       }

    }

  }// end of processEvent()


  /*
  public void
  eventsProcessed()
  {
     currentColor.getValue(colorBuf);
     if(colorBuf[0] >= 0.5 ) isRed.setValue(true);
  }
  */


  /**
  */
  public void
  updateShape(float Cheight, float Cradius, boolean Cbottom, boolean Ctop,
              boolean Cside, boolean Dragging)
  {

     if(DEBUG)
     {
        System.out.println(" Height :"+Cheight);
        System.out.println(" Radius :"+Cradius);
        System.out.println(" Bottom :"+Cbottom);
        System.out.println(" Top    :"+Ctop);
        System.out.println(" Side   :"+Cside);
        System.out.println(" Drag   :"+Dragging);

     }// end of if

     //removeChildren.setValue(myNode);
     addChildrenNode(Cheight, Cradius, Cbottom, Ctop, Cside, Dragging);
     
  }// end of updateShape()

  /**
  */
  void
  addChildrenNode(float Cheight, float Cradius, boolean Cbottom, boolean Ctop,
                  boolean Cside, boolean Dragging)
  {
     System.out.println(" in addChildrenNode() ");
   
     if(DEBUG==true) 
          System.out.println(" height is "+Cheight+" radius "+Cradius+
                             " bottom i s "+Cbottom+ " top is "+Ctop+
                             " side is "+Cside+" Moving is "+Dragging);
          
     String vrmlString = "Group { children [ DEF myCone Transform { "+
                         "children [ Shape { appearance Appearance { "+
                         "material Material {} } geometry Cylinder {"+
                         " radius "+Cradius+" height "+Cheight+
                         " bottom "+(Cbottom==true?"TRUE":"FALSE")+
                         " top "+(Ctop==true?"TRUE":"FALSE")+
                         " side "+(Cside==true?"TRUE":"FALSE")+" } } ] }"+
                          (Dragging==true?" DEF Sensor PlaneSensor { } ] ROUTE Sensor.translation_changed TO myCone.set_translation }": " DEF Sensor SphereSensor { } ] ROUTE Sensor.rotation_changed TO myCone.set_rotation } ");
        
     try 
     {
        System.out.println(" before createVrmlFromString() "+vrmlString);
        BaseNode bn[] = browser.createVrmlFromString(vrmlString);
        System.out.println(" after createVrmlFromString() ");

        myNode.setValue(bn);
        System.out.println(" after  myNode.setValue(bn)" );
        addChildren.setValue(myNode);
        System.out.println(" after  addChildren.setValue(myNode); " );

     } catch(InvalidVRMLSyntaxException ivse)
       { }
      
   }// end of addChildrenNode()

}// end of Example4

